"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var ban_1 = __importDefault(require("react-icons/lib/fa/ban"));
var check_circle_1 = __importDefault(require("react-icons/lib/fa/check-circle"));
var exclamation_triangle_1 = __importDefault(require("react-icons/lib/fa/exclamation-triangle"));
var lightbulb_o_1 = __importDefault(require("react-icons/lib/fa/lightbulb-o"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var DismissableContainer_1 = require("../../internal/DismissableContainer");
var utils_1 = require("../../utils");
var Box_1 = require("../Box");
var Flex_1 = require("../Flex");
var Txt_1 = __importDefault(require("../Txt"));
var getTitle = function (props) {
    if (props.prefix === false) {
        return;
    }
    if (props.prefix !== undefined) {
        return props.prefix;
    }
    return props.danger
        ? 'Oh snap!'
        : props.warning
            ? 'Warning!'
            : props.success
                ? 'Success!'
                : props.info
                    ? 'Note!'
                    : '';
};
var getIcon = function (props) {
    if (props.prefix === false) {
        return;
    }
    if (props.prefix !== undefined) {
        return;
    }
    return props.danger ? (React.createElement(ban_1.default, null)) : props.warning ? (React.createElement(exclamation_triangle_1.default, null)) : props.success ? (React.createElement(check_circle_1.default, null)) : props.info ? (React.createElement(lightbulb_o_1.default, null)) : ('');
};
var Alert = function (props) {
    var emphasized = props.emphasized, plaintext = props.plaintext, prefix = props.prefix, onDismiss = props.onDismiss, restProps = __rest(props, ["emphasized", "plaintext", "prefix", "onDismiss"]);
    var icon = getIcon(props);
    var title = plaintext ? null : getTitle(props);
    var color = utils_1.getColor(props, 'color', 'main');
    var lineHeight = props.theme.fontSizes[1] * props.theme.lineHeight;
    if (plaintext) {
        return (React.createElement(Flex_1.Flex, __assign({ color: color }, restProps),
            icon && (React.createElement(Txt_1.default, { fontSize: 1, mt: '-1px', mb: "auto", mr: 2 }, icon)),
            React.createElement(Txt_1.default.span, { fontSize: 1 }, props.children)));
    }
    return (React.createElement(DismissableContainer_1.DismissableContainer, __assign({ baselineHeight: lineHeight, solid: emphasized, color: color, onDismiss: onDismiss }, restProps),
        icon && (React.createElement(Txt_1.default, { fontSize: 1, mt: '-1px', mb: "auto", mr: 3 }, icon)),
        React.createElement(Box_1.Box, { flex: 1 },
            title && (React.createElement(Txt_1.default.span, { fontSize: 1, bold: true, mr: 2 }, title)),
            React.createElement(Txt_1.default.span, { fontSize: 1, color: emphasized ? 'white' : 'text.main' }, props.children))));
};
exports.default = asRendition_1.default(Alert, [], ['bg']);
