"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var arrayType = __importStar(require("./array"));
var booleanType = __importStar(require("./boolean"));
var dateTimeType = __importStar(require("./date-time"));
var enumType = __importStar(require("./enum"));
var numberType = __importStar(require("./number"));
var objectType = __importStar(require("./object"));
var oneOfType = __importStar(require("./oneOf"));
var stringType = __importStar(require("./string"));
exports.getDataModel = function (schema) {
    if (!schema) {
        return null;
    }
    var format = schema.format, type = schema.type;
    if (schema.enum) {
        return enumType;
    }
    if (schema.oneOf) {
        return oneOfType;
    }
    if (type === 'array') {
        return arrayType;
    }
    if (type === 'string') {
        if (format === 'date-time') {
            return dateTimeType;
        }
        return stringType;
    }
    if (type === 'object') {
        return objectType;
    }
    if (type === 'boolean') {
        return booleanType;
    }
    if (type === 'number') {
        return numberType;
    }
    return null;
};
