/// <reference types="react" />
import { JSONSchema6 } from 'json-schema';
import { DataTypeEditProps } from '../Filters';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema6) => string;
    };
    is_more_than: {
        getLabel: (_s: JSONSchema6) => string;
    };
    is_less_than: {
        getLabel: (_s: JSONSchema6) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface NumberFilter extends JSONSchema6 {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            type: 'number';
            const?: number;
            exclusiveMinimum?: number;
            exclusiveMaximum?: number;
        };
    };
}
export declare const decodeFilter: (filter: NumberFilter) => {
    field: string;
    operator: "is" | "is_more_than" | "is_less_than";
    value: number;
} | null;
export declare const createFilter: (field: string, operator: "is" | "is_more_than" | "is_less_than", value: any, schema: JSONSchema6) => NumberFilter;
export declare const Edit: ({ value, onUpdate, ...props }: DataTypeEditProps & import("../Input").InternalInputProps & import("../..").Tooltip & import("../..").StyledSystemProps & {
    slim?: boolean | undefined;
}) => JSX.Element;
export {};
