"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var check_circle_1 = __importDefault(require("react-icons/lib/fa/check-circle"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var DismissableContainer_1 = require("../../internal/DismissableContainer");
var utils_1 = require("../../utils");
var Flex_1 = require("../Flex");
var Heading_1 = __importDefault(require("../Heading"));
var Link_1 = __importDefault(require("../Link"));
var Txt_1 = __importDefault(require("../Txt"));
var Arrow_1 = require("./Arrow");
var getStatusColor = function (theme, status) {
    switch (status) {
        case 'pending':
            return theme.colors.tertiary.semilight;
        case 'completed':
            return theme.colors.success.main;
    }
};
var StatusIconPlaceholder = styled_components_1.default.span(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-size: ", ";\n\tcolor: ", ";\n\tline-height: 0.8; /* We need this to normalize the icon's height */\n"], ["\n\tfont-size: ", ";\n\tcolor: ", ";\n\tline-height: 0.8; /* We need this to normalize the icon's height */\n"])), function (props) { return utils_1.px(props.theme.fontSizes[5]); }, function (props) { return getStatusColor(props.theme, props.status); });
var HeaderContainer = styled_components_1.default(Flex_1.Flex)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tmin-height: ", ";\n"], ["\n\tmin-height: ", ";\n"])), function (props) { return utils_1.px(props.theme.fontSizes[5]); });
exports.Step = function (_a) {
    var status = _a.status, children = _a.children, onClick = _a.onClick;
    if (typeof children !== 'string') {
        throw new Error('The child of a Step has to be a string.');
    }
    return (React.createElement(Flex_1.Flex, { flexDirection: "row", justifyContent: "center", alignItems: "center" },
        React.createElement(StatusIconPlaceholder, { status: status },
            React.createElement(check_circle_1.default, null)),
        onClick ? (React.createElement(Link_1.default, { ml: 2, onClick: onClick }, children)) : (React.createElement(Txt_1.default, { ml: 2 }, children))));
};
var FramelessSteps = function (_a) {
    var children = _a.children, otherProps = __rest(_a, ["children"]);
    return (React.createElement(Flex_1.Flex, __assign({ mx: "auto", flexDirection: "row", alignItems: "center", flexWrap: "wrap" }, otherProps), React.Children.map(children, function (step, index) {
        if (step.type !== exports.Step) {
            throw new Error('You can only use Step components as children of Steps.');
        }
        return (React.createElement(Flex_1.Flex, { flexDirection: "row", alignItems: "center" },
            step,
            index < children.length - 1 && (React.createElement(Flex_1.Flex, { justifyContent: "center", alignItems: "center", mx: 3 },
                React.createElement(Arrow_1.Arrow, null)))));
    })));
};
var Steps = React.forwardRef(function (_a, ref) {
    var className = _a.className, children = _a.children, titleText = _a.titleText, titleIcon = _a.titleIcon, onClose = _a.onClose;
    return (React.createElement(DismissableContainer_1.DismissableContainer, { p: 3, className: className, flexDirection: "row", justifyContent: "space-between", flexWrap: "wrap", alignItems: "center", onDismiss: onClose, baselineHeight: 32, ref: ref },
        (titleText || titleIcon) && (React.createElement(HeaderContainer, { justifyContent: "center", alignItems: "center", ml: 2, mr: 4 },
            titleIcon && (React.createElement(Txt_1.default, { fontSize: 2, mr: 2, color: "tertiary.semilight" }, titleIcon)),
            titleText && (React.createElement(Heading_1.default.h6, { color: "tertiary.main" }, titleText)))),
        React.createElement(FramelessSteps, null, children)));
});
exports.default = asRendition_1.default(Steps);
var templateObject_1, templateObject_2;
