"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var arrow_down_1 = __importDefault(require("react-icons/lib/fa/arrow-down"));
var arrow_up_1 = __importDefault(require("react-icons/lib/fa/arrow-up"));
var close_1 = __importDefault(require("react-icons/lib/fa/close"));
var plus_1 = __importDefault(require("react-icons/lib/fa/plus"));
var styled_components_1 = __importDefault(require("styled-components"));
var __1 = require("../../../../");
var WarningField_1 = require("../WarningField");
var ArrayFieldTitle = function (_a) {
    var TitleField = _a.TitleField, idSchema = _a.idSchema, required = _a.required, title = _a.title;
    if (!title) {
        return null;
    }
    var id = idSchema.$id + "__title";
    return React.createElement(TitleField, { id: id, title: title, required: required });
};
var ArrayFieldDescription = function (_a) {
    var DescriptionField = _a.DescriptionField, idSchema = _a.idSchema, description = _a.description;
    if (!description) {
        return null;
    }
    var id = idSchema.$id + "__description";
    return React.createElement(DescriptionField, { id: id, description: description });
};
var ActionButton = styled_components_1.default(__1.Button)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tcolor: ", ";\n"], ["\n\tcolor: ", ";\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colors.text.light;
});
exports.default = (function (props) {
    var warning = props.uiSchema['ui:warning'];
    return (React.createElement("div", { className: props.uiSchema.classNames },
        React.createElement(ArrayFieldTitle, { TitleField: props.TitleField, idSchema: props.idSchema, title: props.uiSchema['ui:title'] || props.title, required: props.required }),
        !!warning && React.createElement(WarningField_1.WarningField, { warning: warning }),
        React.createElement(ArrayFieldDescription, { DescriptionField: props.DescriptionField, idSchema: props.idSchema, description: props.uiSchema['ui:description'] || props.schema.description }),
        props.items.map(function (element) {
            return (React.createElement("div", { className: "rendition-form__array-item", key: element.index },
                React.createElement(__1.Flex, { alignItems: "flex-start" },
                    React.createElement(__1.Box, { flex: "1" }, element.children),
                    props.items.length > 1 && (React.createElement(ActionButton, { type: "button", className: "rendition-form-array-item__move-up", mb: "6px", px: 1, mt: 1, ml: 1, plain: true, disabled: element.disabled || element.readonly || !element.hasMoveUp, onClick: element.onReorderClick(element.index, element.index - 1) },
                        React.createElement(arrow_up_1.default, null))),
                    props.items.length > 1 && (React.createElement(ActionButton, { type: "button", className: "rendition-form-array-item__move-down", mb: "6px", px: 1, mt: 1, ml: 1, plain: true, disabled: element.disabled || element.readonly || !element.hasMoveDown, onClick: element.onReorderClick(element.index, element.index + 1) },
                        React.createElement(arrow_down_1.default, null))),
                    element.hasRemove && (React.createElement(ActionButton, { type: "button", className: "rendition-form-array-item__remove-item", plain: true, mb: "6px", mt: 1, px: 1, ml: 1, disabled: element.disabled || element.readonly, onClick: element.onDropIndexClick(element.index) },
                        React.createElement(close_1.default, null))))));
        }),
        props.canAdd && (React.createElement(__1.Button, { type: "button", className: "rendition-form-array-item__add-item", icon: React.createElement(plus_1.default, null), onClick: props.onAddClick }, "Add item"))));
});
var templateObject_1;
