import { __assign, __rest } from "tslib";
import * as React from 'react';
import FaBan from 'react-icons/lib/fa/ban';
import FaCheckCircle from 'react-icons/lib/fa/check-circle';
import FaExclamationTriangle from 'react-icons/lib/fa/exclamation-triangle';
import FaLightbulb from 'react-icons/lib/fa/lightbulb-o';
import asRendition from '../../asRendition';
import { DismissableContainer } from '../../internal/DismissableContainer';
import { getColor } from '../../utils';
import { Box } from '../Box';
import { Flex } from '../Flex';
import Txt from '../Txt';
var getTitle = function (props) {
    if (props.prefix === false) {
        return;
    }
    if (props.prefix !== undefined) {
        return props.prefix;
    }
    return props.danger
        ? 'Oh snap!'
        : props.warning
            ? 'Warning!'
            : props.success
                ? 'Success!'
                : props.info
                    ? 'Note!'
                    : '';
};
var getIcon = function (props) {
    if (props.prefix === false) {
        return;
    }
    if (props.prefix !== undefined) {
        return;
    }
    return props.danger ? (React.createElement(FaBan, null)) : props.warning ? (React.createElement(FaExclamationTriangle, null)) : props.success ? (React.createElement(FaCheckCircle, null)) : props.info ? (React.createElement(FaLightbulb, null)) : ('');
};
var Alert = function (props) {
    var emphasized = props.emphasized, plaintext = props.plaintext, prefix = props.prefix, onDismiss = props.onDismiss, restProps = __rest(props, ["emphasized", "plaintext", "prefix", "onDismiss"]);
    var icon = getIcon(props);
    var title = plaintext ? null : getTitle(props);
    var color = getColor(props, 'color', 'main');
    var lineHeight = props.theme.fontSizes[1] * props.theme.lineHeight;
    if (plaintext) {
        return (React.createElement(Flex, __assign({ color: color }, restProps),
            icon && (React.createElement(Txt, { fontSize: 1, mt: '-1px', mb: "auto", mr: 2 }, icon)),
            React.createElement(Txt.span, { fontSize: 1 }, props.children)));
    }
    return (React.createElement(DismissableContainer, __assign({ baselineHeight: lineHeight, solid: emphasized, color: color, onDismiss: onDismiss }, restProps),
        icon && (React.createElement(Txt, { fontSize: 1, mt: '-1px', mb: "auto", mr: 3 }, icon)),
        React.createElement(Box, { flex: 1 },
            title && (React.createElement(Txt.span, { fontSize: 1, bold: true, mr: 2 }, title)),
            React.createElement(Txt.span, { fontSize: 1, color: emphasized ? 'white' : 'text.main' }, props.children))));
};
export default asRendition(Alert, [], ['bg']);
